## djstub 0.0~git20240625.8cfa572

=== Makefile ===
OBJCOPY = objcopy
O_BFDARCH=$(shell $(OBJCOPY) --info 2>/dev/null | head -n 2 | tail -n 1)
ifeq ($(O_BFDARCH),)
O_BFDARCH = elf64-x86-64
endif
PROG = djstubify
PREFIX ?= /usr/local
BINDIR ?= $(PREFIX)/bin
CFLAGS ?= -Wall -Og -g
# set to mini or full
STYPE = mini
STUB = $(STYPE)stub.exe
CPPFLAGS += \
  -D_binary_stub_exe_start=_binary_$(STYPE)stub_exe_start \
  -D_binary_stub_exe_end=_binary_$(STYPE)stub_exe_end \
  -D_binary_stub_exe_size=_binary_$(STYPE)stub_exe_size

all: $(PROG)

.PHONY: $(STYPE)
$(STUB): $(STYPE)
	$(MAKE) -C $<

binstub.o: $(STUB)
	$(OBJCOPY) -I binary -O $(O_BFDARCH) \
		--add-section .note.GNU-stack=/dev/null $< $@

$(PROG): stubify.o binstub.o
	$(CC) $(LDFLAGS) -o $@ $^

install:
	install -d $(DESTDIR)$(BINDIR)
	install -m 0755 $(PROG) $(DESTDIR)$(BINDIR)
	install -m 0755 djstrip $(DESTDIR)$(BINDIR)
	install -m 0755 djlink $(DESTDIR)$(BINDIR)

uninstall:
	$(RM) $(DESTDIR)$(BINDIR)/$(PROG)
	$(RM) $(DESTDIR)$(BINDIR)/djstrip
	$(RM) $(DESTDIR)$(BINDIR)/djlink

deb:
	debuild -i -us -uc -b

clean:
	$(MAKE) -C $(STYPE) clean
	rm -f *.o $(STUB) $(PROG)

=== debian/changelog ===
djstub (0.0~git20240625.8cfa572-1) unstable; urgency=medium

  * New upstream snapshot.
  * Clarify the package description.

 -- Stephen Kitt <skitt@debian.org>  Sat, 20 Jul 2024 11:51:22 +0200

djstub (0.0~git20240621.49e7ba6-1~exp1) experimental; urgency=low

  * Initial release. Closes: #1074057.

 -- Stephen Kitt <skitt@debian.org>  Fri, 21 Jun 2024 12:26:49 +0200

=== debian/watch ===
version=4

opts="mode=git, pgpmode=none" \
https://github.com/stsp/djstub \
HEAD debian uupdate

## djstub 0.0~git20241017.40bd05f

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,4 @@
+VER = 0.2
 OBJCOPY = objcopy
 O_BFDARCH=$(shell $(OBJCOPY) --info 2>/dev/null | head -n 2 | tail -n 1)
 ifeq ($(O_BFDARCH),)
@@ -13,7 +14,8 @@
 CPPFLAGS += \
   -D_binary_stub_exe_start=_binary_$(STYPE)stub_exe_start \
   -D_binary_stub_exe_end=_binary_$(STYPE)stub_exe_end \
-  -D_binary_stub_exe_size=_binary_$(STYPE)stub_exe_size
+  -D_binary_stub_exe_size=_binary_$(STYPE)stub_exe_size \
+  -DVERSION=$(VER)
 
 all: $(PROG)

=== debian/changelog ===
djstub (0.0~git20241017.40bd05f-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Stephen Kitt <skitt@debian.org>  Wed, 06 Nov 2024 08:04:21 +0100

## djstub 0.3

=== Makefile ===
--- 
+++ 
@@ -1,16 +1,12 @@
 VER = 0.2
-OBJCOPY = objcopy
-O_BFDARCH=$(shell $(OBJCOPY) --info 2>/dev/null | head -n 2 | tail -n 1)
-ifeq ($(O_BFDARCH),)
-O_BFDARCH = elf64-x86-64
-endif
 PROG = djstubify
-PREFIX ?= /usr/local
-BINDIR ?= $(PREFIX)/bin
+prefix ?= /usr/local
+BINDIR ?= $(prefix)/bin
 CFLAGS ?= -Wall -Og -g
 # set to mini or full
 STYPE = mini
 STUB = $(STYPE)stub.exe
+STUB_S = $(STYPE)stub.S
 CPPFLAGS += \
   -D_binary_stub_exe_start=_binary_$(STYPE)stub_exe_start \
   -D_binary_stub_exe_end=_binary_$(STYPE)stub_exe_end \
@@ -23,9 +19,8 @@
 $(STUB): $(STYPE)
 	$(MAKE) -C $<
 
-binstub.o: $(STUB)
-	$(OBJCOPY) -I binary -O $(O_BFDARCH) \
-		--add-section .note.GNU-stack=/dev/null $< $@
+binstub.o: $(STUB_S) $(STUB)
+	$(CC) -c -o $@ $<
 
 $(PROG): stubify.o binstub.o
 	$(CC) $(LDFLAGS) -o $@ $^

=== full/Makefile ===
TOP = ..
TGT = $(TOP)/fullstub.exe
CC = ia16-elf-gcc
CFLAGS = -mcmodel=small -mdosx32 -Os -Wall
LDFLAGS = -mcmodel=small -mdosx32 -li86
CFILES = stub.c coff.c elf.c util.c
OBJECTS = $(CFILES:.c=.o)

all: $(TGT)

$(OBJECTS): $(CFILES) $(wildcard *.h)

ifneq ($(shell $(CC) --version 2>/dev/null),)
$(TGT): $(OBJECTS)
	$(CC) $^ $(LDFLAGS) -o _$@
	lfanew -o $@ _$@
	rm _$@
else
$(error ia16-gcc not installed)
endif

=== debian/changelog ===
djstub (0.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: upstream now tags releases.

 -- Stephen Kitt <skitt@debian.org>  Tue, 31 Dec 2024 11:31:52 +0100

=== debian/control ===
Source: djstub
Section: otherosfs
Priority: optional
Maintainer: Stephen Kitt <skitt@debian.org>
Standards-Version: 4.7.0
Build-Depends:
 debhelper-compat (= 13),
 smallerc (>= 1.0.1+git20240427~)
Homepage: https://github.com/stsp/djstub
Vcs-Browser: https://salsa.debian.org/debian/djstub
Vcs-Git: https://salsa.debian.org/debian/djstub.git
Rules-Requires-Root: no

Package: djstub
Architecture: any
Depends:
 binutils,
 ${misc:Depends},
 ${shlibs:Depends}
Description: DJGPP-compatible stub manipulation tools
 This package provides DJGPP-compatible tools to manipulate stubbed
 executables, i.e. the MS-DOS MZ launcher for DOS-extended binaries:
 .
  - djstubify to modify the stub itself, in COFF and PE executables;
  - djlink to link ELF binaries and produce a dj64 executable;
  - djstrip to strip dj64 executables.
 .
 It includes a stub with COFF and ELF loaders, capable of loading
 DJGPP- or dj64dev-built executables under dosemu2. This stub requires
 dosemu2 and cannot be used in other environments.

## djstub 0.6

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,3 @@
-VER = 0.2
 PROG = djstubify
 prefix ?= /usr/local
 BINDIR ?= $(prefix)/bin
@@ -10,8 +9,7 @@
 CPPFLAGS += \
   -D_binary_stub_exe_start=_binary_$(STYPE)stub_exe_start \
   -D_binary_stub_exe_end=_binary_$(STYPE)stub_exe_end \
-  -D_binary_stub_exe_size=_binary_$(STYPE)stub_exe_size \
-  -DVERSION=$(VER)
+  -D_binary_stub_exe_size=_binary_$(STYPE)stub_exe_size
 
 all: $(PROG)

=== debian/changelog ===
djstub (0.6-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.7.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 02 May 2025 17:20:59 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: otherosfs
 Priority: optional
 Maintainer: Stephen Kitt <skitt@debian.org>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends:
  debhelper-compat (= 13),
  smallerc (>= 1.0.1+git20240427~)

## djstub 0.7

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 PROG = djstubify
+VER = 7
 prefix ?= /usr/local
 BINDIR ?= $(prefix)/bin
 CFLAGS ?= -Wall -Og -g
@@ -6,7 +7,7 @@
 STYPE = mini
 STUB = $(STYPE)stub.exe
 STUB_S = $(STYPE)stub.S
-CPPFLAGS += \
+CPPFLAGS += -DDJSTUB_VER=$(VER) \
   -D_binary_stub_exe_start=_binary_$(STYPE)stub_exe_start \
   -D_binary_stub_exe_end=_binary_$(STYPE)stub_exe_end \
   -D_binary_stub_exe_size=_binary_$(STYPE)stub_exe_size
@@ -28,11 +29,13 @@
 	install -m 0755 $(PROG) $(DESTDIR)$(BINDIR)
 	install -m 0755 djstrip $(DESTDIR)$(BINDIR)
 	install -m 0755 djlink $(DESTDIR)$(BINDIR)
+	install -m 0755 djelfextract $(DESTDIR)$(BINDIR)
 
 uninstall:
 	$(RM) $(DESTDIR)$(BINDIR)/$(PROG)
 	$(RM) $(DESTDIR)$(BINDIR)/djstrip
 	$(RM) $(DESTDIR)$(BINDIR)/djlink
+	$(RM) $(DESTDIR)$(BINDIR)/djelfextract
 
 deb:
 	debuild -i -us -uc -b

=== mini/Makefile ===
TOP = ..
TGT = $(TOP)/ministub.exe
CC = smlrcc
SMFLAGS = -dosp

ifneq ($(SMPATH),)
SMFLAGS += -I $(SMPATH)/v0100/include -SL $(SMPATH)
define P
PATH=$(SMPATH):$(PATH)
endef
endif

all: $(TGT)

$(TGT): ministub.c
	$(P) $(CC) $(SMFLAGS) $< -o $@

clean:

=== debian/changelog ===
djstub (0.7-1) unstable; urgency=medium

  * New upstream release.
  * Drop “Rules-Requires-Root: no” since it’s now the default.

 -- Stephen Kitt <skitt@debian.org>  Sun, 05 Oct 2025 10:14:41 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
 Homepage: https://github.com/stsp/djstub
 Vcs-Browser: https://salsa.debian.org/debian/djstub
 Vcs-Git: https://salsa.debian.org/debian/djstub.git
-Rules-Requires-Root: no
 
 Package: djstub
 Architecture: any
@@ -23,6 +22,7 @@
  .
   - djstubify to modify the stub itself, in COFF and PE executables;
   - djlink to link ELF binaries and produce a dj64 executable;
+  - djelfextract to extract an ELF binary from a dj64 executable;
   - djstrip to strip dj64 executables.
  .
  It includes a stub with COFF and ELF loaders, capable of loading

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/stsp/djstub/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
